# Rust By Practice

This book was designed for easily diving into Rust，and it's very easy to use: All you need to do is to make each exercise comipile without ERRORS and Panics !

  
## Features

- There are three parts in each chapter: examples, exercises and practices
- Covering nearly all aspects of Rust, such as **async/await, threads, sync primitives, optimizing and stand libraries** etc
- Solutions
- Difficulty from easy to super hard: easy 🌟  medium 🌟🌟 hard 🌟🌟🌟  super hard 🌟🌟🌟🌟
- Both [English](https://practice.rs) and [Chinsese](https://zh.practice.rs) are supported



## ToC
- [Variables](src/variables.md)
- [Basic Types](src/basic-types/intro.md)
  - [Numbers](src/basic-types/numbers.md)
  - [Char, Bool and Unit](src/basic-types/char-bool-unit.md)
  - [Statements and Expressions](src/basic-types/statements-expressions.md)
  - [Functions](src/basic-types/functions.md)
- [Ownership and Borrowing](src/ownership/intro.md)
  - [Ownership](src/ownership/ownership.md)
  - [Reference and Borrowing](src/ownership/borrowing.md)
- [Compound Types](src/compound-types/intro.md)
  - [string](src/compound-types/string.md)
  - [Array](src/compound-types/array.md)
  - [Slice](src/compound-types/slice.md)
  - [Tuple](src/compound-types/tuple.md)
  - [Struct](src/compound-types/struct.md)
  - [Enum](src/compound-types/enum.md)
- [Flow Control](src/flow-control.md)
- [Pattern Match](src/pattern-match/intro.md)
  - [match, matches! and if let](src/pattern-match/match-iflet.md)
  - [Patterns](src/pattern-match/patterns.md)

